#!/usr/bin/perl

use strict;
use integer;

my $Name = "1DPH";
my $Offset = "2IIVHW";

if (!open(FILE, "reg_xref.txt")) {
	die();
}

my @word;

while (chomp(my $line = <FILE>)) {
	if ($line eq "6.2") {
		last;
	}
}

while (chomp(my $line = <FILE>)) {
	if ($line ne "") {
		my @prev_word = @word;
		@word = split(/ /, $line);
		my @register;
		my @offset;

		if ($prev_word[0] eq $Name) {
			push(@register, @word);

			my @new_word;
			my @new_prev_word;
			do {
				chomp($line = <FILE>);
				if ($line ne "") {
					@new_prev_word = @new_word;
					@new_word = split(/ /, $line);

					if ($new_prev_word[0] eq $Offset) {
						push(@offset, @new_word);
					}
				}
			} while ($new_prev_word[0] ne $Offset);

			if ((scalar @register) != (scalar @offset)) {
				printf("DELETE uh-oh, register is %d, offset is %d\n", scalar @register, scalar @offset);
			}

			while (@register || @offset) {
				my $more_registers = defined($register[0]);
				my $more_offsets = defined($offset[0]);
				if ($more_registers && $more_offsets) {
					printf("%#06x %s\n", hex(shift(@offset)), shift(@register));
				} elsif ($more_registers) {
					printf("0xASDF %s\n", shift(@register));
				} elsif ($more_offsets) {
					printf("%#06x\n", hex(shift(@offset)));
				}
			}
		}
	}
}

close(FILE);
