#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
 * Find line beginning with '1DPH' ('Name') then read until you hit
 * '7\SH' ('Type'). Between Name and Type are the register names.
 *
 * Skip reading until '2IIVHW' ('Offset'), the next things read until
 * ')RUPDW' ('Format') are the register offsets.
 */

#define BUF_SIZE 4096

static void translate(char * input) {
	int i;
	for (i = 0; i < strlen(input); i++) {
		input[i] += 29;
	}
}

int main() {
	FILE *fp;

	fp = fopen("p4-rg-v2.txt", "r");
	if (!fp) {
		fprintf(stderr, "couldn't open file\n");
		return -1;
	}
	int i = 0;
	while (!feof(fp)) {
		char buffer[BUF_SIZE];
		fgets(buffer, BUF_SIZE, fp);
#ifdef DEBUG
		printf("%d\n", ++i);
#endif

		if (!strncmp(buffer, "1DPH", 4)) {
			char * ptr;

			ptr = strtok(buffer + 4, " ");
			while (1) {
				if (ptr == NULL) {
#ifdef DEBUG
					puts("ptr == NULL");
#endif
					break;
				}
				if (!strncmp(ptr, "7\\SH", 4)) {
#ifdef DEBUG
					puts("found Type");
#endif
					break;
				}
				translate(ptr);
				printf("\n#define %s\t", ptr);
				ptr = strtok(NULL, " ");
			}

			while (1) {
				if (ptr == NULL) {
#ifdef DEBUG
					puts("ptr == NULL");
#endif
					break;
				}
				if (!strncmp(ptr, "2IIVHW", 6)) {
#ifdef DEBUG
					puts("found Offset");
#endif
					break;
				}
				ptr = strtok(NULL, " ");
			}

			while (1) {
				if (ptr == NULL) {
#ifdef DEBUG
					puts("ptr == NULL\n");
#endif
					break;
				}
				if (!strncmp(ptr, ")RUPDW", 6)) {
#ifdef DEBUG
					puts("found Format\n");
#endif
					break;
				}
				translate(ptr);
				if (strncmp(ptr, "Offset", 6) && strncmp(ptr, "Read", 4) && ptr[strlen(ptr)] != '\'') {
					int num;
					if (!strncmp(ptr, "0x ", 3)) {
						ptr = strtok(NULL, " ");
						printf("HERE HERE %s\n", ptr);
						translate(ptr);
						sscanf(ptr, "%x", &num);
						printf("%#06X\n", num);
					} else if (!strncmp(ptr, "0x", 2)) {
						sscanf(ptr, "%x", &num);
						printf("%#06X\n", num);
					}
				}
				ptr = strtok(NULL, " ");
			}
		}
	}

	fclose(fp);
	return 0;
}
