#!/usr/bin/perl

use strict;
use integer;
#use warnings;

sub translate {
	my @ascii = unpack("C*", $_[0]);
	for (my $i = 0; $i < @ascii; $i++) {
		$ascii[$i] += 29;
	}
	return pack("C*", @ascii);
}

sub howmanyhex {
	my $num = 0;
	foreach (@_) {
		if ($_ =~ m/^0x/) {
			$num++;
		}
	}
	return $num;
}

sub gethex {
	my $hex;
	foreach (@_) {
		if ($_ =~ m/^0x/) {
			return $_;
		}
	}
	return "not found";
}

my $Name = "1DPH";
my $Type = "7\\SH";
my $Offset = "2IIVHW";
my $Format = ")RUPDW";


if (!open(FILE, "p4-rg-v2.txt")) {
	die();
}

while (chomp(my $line = <FILE>)) {
	if ($line ne "") {
		my @word = split(/ /, $line);
		my @register;
		my @offset;

		if (defined($word[0]) && $word[0] eq $Name) {
			my $i = 1;
			while (defined($word[$i]) && $word[$i] ne $Type) {
				push(@register, translate($word[$i]));
				$i++;
			}

			$i++ while (defined($word[$i]) && $word[$i] ne $Offset);
			$i++;

			while (defined($word[$i]) && $word[$i] ne $Format) {
				push(@offset, translate($word[$i]));
				$i++;
			}
		
			for (my $j = 0; $j < @offset; $j++) {
				if ($offset[$j] eq '0x') {
					#print("TRUE TRUE TRUE\n");
					$offset[$j] .= $offset[$j + 1];
					#printf("new is %s and hex is %#06X\n", $offset[$j], $offset[$j]);
					splice(@offset, $j, 1);
					$j--;
				}
			}

			my $numhex = howmanyhex(@offset);

			print "DELETE --------------------------------\n";
			if ($numhex == @offset && @register == @offset) {
				for (my $i = 0; $i < $numhex; $i++) {
					printf("#define %s %#06x\n", shift(@register), hex(shift(@offset)));
				}
			} else {

				printf("DELETE \@register: %d, \@offset %d\n", scalar @register, scalar @offset);
				printf("DELETE there are %d hex numbers in \@offset\n", $numhex);
	
				if (howmanyhex(@offset) != 0) {
					while (@register && @offset) {
						print("(the offset is " . gethex(@offset) . ")\n");
						if ($offset[0] =~ m/^0x/) {
							printf("#define %s %#06X\n", shift(@register), hex(shift(@offset)));
						} else {
							# everytime we hit this, the real offset is the picked correctly by gethex()
							printf("#define %s %s\n", shift(@register), hex(gethex(@offset)));
						}
					}
					while (@register) {
						printf("register %s\n", shift(@register));
					}
					while (@offset) {
						printf("offset %s\n", shift(@offset));
					}
				}
			}
		}
	}
}

close(FILE);
