/* PCI Configuration Region (0x00-0x30) */
#define CFGAGPCommand 0x0048
#define CFGACGRev 0x0042
#define CFGAGPStatus 0x0044
#define CFGBaseAddr0 0x0010
#define CFGBaseAddr1 0x0014
#define CFGBaseAddr2 0x0018
#define CFGBIST 0x000f
#define CFGCacheLine 0x000c
#define CFGCapID 0x0040
#define CFGCapPtr 0x0034
#define CFGCardBus 0x0028
#define CFGClassCode 0x0009
#define CFGCommand 0x0004
#define CFGDeviceID 0x0002
#define CFGHeaderType 0x000e
#define CFGIndirectAddress 0x00f8
#define CFGIndirectData 0x00f4
#define CFGIndirectTrigger 0x00fc
#define CFGIntLine 0x003c
#define CFGIntPin 0x003d
#define CFGLatTimer 0x000d
#define CFGMaxLat 0x003f
#define CFGMinGrant 0x003e
#define CFGNextPtr 0x0041
#define CFGPMC 0x004e
#define CFGPMCapID 0x004c
#define CFGPMCS 0x0050
#define CFGPMCSR_BSE 0x0052
#define CFGPMData 0x0053
#define CFGPMNextPtr 0x004d
#define CFGRevisionID 0x0008
#define CFGRomAddr 0x0030
#define CFGStatus 0x0006
#define CFGSubsystemId 0x002e
#define CFGSubsystemVendorId 0x002c
#define CFGVendorID 000000
#define AGPControl 0x0078
#define ApertureOne 0x0050
#define ApertureTwo 0x0058
#define AutoCalCount 0x00f8
#define ChipConfig 0x0070
#define ControlDMAAddress 0x0028
#define ControlDMAControl 0x0060
#define ControlDMACount 0x0030
#define ErrorFlags 0x0038
#define FIFODiscon 0x0068
#define GPOutDMAAddress 0x0080
#define HostTextureAddress 0x0100
#define InFIFOSpace 0x0018
#define IntEnable 0x0008
#define IntFlags 0x0010
#define LogicalTexturePage 0x0118
#define OutFIFOWords 0x0020
#define PCIAbortAddress 0x0098
#define PCIAbortStatus 0x0090
#define PCIFeedbackCount 0x0088
#define PCIPLLStatus 0x00f0
#define ResetStatus 000000
#define TexDMAAddress 0x0120
#define TexFIFOSpace 0x0128
#define TextureDownloadControl 0x0108
#define TextureOperation 0x0110
#define VClkRDacCtl 0x0040
/* Region 0 Bypass Controls (0x0300-0x03FF) */
#define ByAperture1Mode 0x0300
#define ByAperture2Mode 0x0328
#define ByAperture1UStart 0x0318
#define ByAperture2UStart 0x0340
#define ByAperture1VStart 0x0320
#define ByAperture2VStart 0x0348
#define ByAperture1YStart 0x0310
#define ByAperture2YStart 0x0338
#define ByAperture1Stride 0x0308
#define ByAperture2Stride 0x0330
#define ByDMAReadCommandBase 0x0378
#define ByDMAReadCommandCount 0x0380
#define ByDMAReadMode 0x0350
#define ByDMAReadStride 0x0358
#define ByDMAReadUStart 0x0368
#define ByDMAReadVStart 0x0370
#define ByDMAReadYStart 0x0360
#define ByDMAWriteCommandBase 0x03B0
#define ByDMAWriteCommandCount 0X03B8
#define ByDMAWriteMode 0x0388
#define ByDMAWriteStride 0x0390
#define ByDMAWriteUStart 0x03a0
#define ByDMAWriteVStart 0x03a8
#define ByDMAWriteYStart 0x0398
/* Region 0 Memory Control (0x1000-0x1FFF) */
#define LocalMemCaps 0x1018
#define LocalMemControl 0x1028
#define LocalMemPowerDown 0x1038
#define LocalMemRefresh 0x1030
#define LocalMemTiming 0x1020
#define MemBypassWriteMask 0x1008
#define MemCounter 0x1000
#define MemScratch 0x1010
#define RemoteMemControl 0x1100
/* Region 0 GP FIFO (0x2000-0x2FFF) */
/* No 0x2000 series registers are listed. */
/* Region 0 Video Control (0x3000-0x3FFF) */
#define DisplayData 0x3068
#define FifoControl 0x3078
#define HbEnd 0x3020
#define HgEnd 0x3018
#define HsEnd 0x3030
#define HsStart 0x3028
#define HTotal 0x3010
#define InterruptLine 0x3060
#define MiscControl 0x3088
#define ScreenBase 0x3000
#define ScreenBaseRight 0x3080
#define ScreenStride 0x3008
#define VbEnd 0x3040
#define VerticalLineCount 0x3070
#define VideoControl 0x3058
#define VideoOverlayBase0 0x3120
#define VideoOverlayBase1 0x3128
#define VideoOverlayBase2 0x3130
#define VideoOverlayFieldOffset 0x3170
#define VideoOverlayFIFOControl 0x3110
#define VideoOverlayHeight 0x3148
#define VideoOverlayIndex 0x3118
#define VideoOverlayMode 0x3108
#define VideoOverlayOrigin 0x3150
#define VideoOverlayShrinkXDelta 0x3158
#define VideoOverlayStatus 0x3178
#define VideoOverlayStride 0x3138
#define VideoOverlayWidth 0x3140
#define VideoOverlayYDelta 0x3168
#define VideoOverlayZoomXDelta 0x3160
#define VsEnd 0x3050
#define VsStart 0x3048
#define VTotal 0x3038
/* Direct RAMDAC Registers (0x4000 - 0x4FFF) */
#define RDIndexControl 0x4038
#define RDIndexedData 0x4030
#define RDIndexHigh 0x4028
#define RDIndexLow 0x4020
#define RDCheckControl 0x0018
/* Indirect RAMDAC Registers (0x0200 - 0x0FFF) */
#define RDCheckControl 0x0018
#define RDCheckLUTBlue 0x001e
#define RDCheckLUTGreen 0x001d
#define RDCheckLUTRed 0x001c
#define RDCheckPixelBlue 0x001b
#define RDCheckPixelGreen 0x001a
#define RDCheckPixelRed 0x0019
#define RDColorFormat 0x0004
#define RDCursorControl 0x0006
#define RDCursorHotSpotX 0x000b
#define RDCursorHotSpotY 0x000c
#define RDCursorMode 0x0005
/* #define RDCursorPalette[0..44] 0x0303 to 0x032f FIXME */
/* #define RDCursorPattern[0..1023] 0x0400 to 0x07ff FIXME */
#define RDCursortXHigh 0x0008
#define RDCursortXLow 0x0007
#define RDCursorYHigh 0x000a
#define RDCursorYLow 0x0009
#define RDDACControl 0x0002
#define RDDClk0FeedbackScale 0x0202
#define RDDClk0PostScale 0x0203
#define RDDClk1PostScale 0x0206
#define RDKClkPostScale 0x0210
#define RDDClk2PostScale 0x0209
#define RDDClk3PostScale 0x020c
#define RDDClk0PreScale 0x0201
#define RDDClk1FeedbackScale 0x024f
#define RDDClk1PreScale 0x0028
#define RDDClk2FeedbackScale 0x0208
#define RDDClk3FeedbackScale 0x020b
#define RDDClk2PreScale 0x0207
#define RDDClk3PreScale 0x020a
#define RDDClkControl 0x0200
#define RDDClkSetup1 0x01f0
#define RDKClkSetup1 0x01f2
#define RDDClkSetup2 0x01f1
#define RDKClkSetup2 0x01f3
#define RDKClkControl 0x020d /* RDK_c_lkControl in Permedia4 Reference Guide Volume II */
#define RDKClkFeedbackScale 0x020f
#define RDKClkPreScale 0x020e
#define RDMClkControl 0x0211
#define RDMiscControl 0x0000
#define RDOverlayKey 0x000d
#define RDPaletteData 0x4008
#define RDPaletteReadAddress 0x4018
#define RDPaletteWriteAddress 0x4000
#define RDPan 0x000e
#define RDPixelMask 0x4010
#define RDPixelSize 0x0003
#define RDSClkControl 0x0215
#define RDScratch 0x001f
#define RDSense 0x000f
#define RDSyncControl 0x0001
#define RDVideoOverlayBlend 0x002c
#define RDVideoOverlayControl 0x0020
#define RDVideoOverlayKeyB 0x002b
#define RDVideoOverlayKeyG 0x002a
#define RDVideoOverlayKeyR 0x0029
#define RDVideoOverlayXEndHigh 0x0026
#define RDVideoOverlayXEndLow 0x0025
#define RDVideoOverlayXStartHigh 0X0022
#define RDVideoOverlayXStartLow 0X0021
#define RDVideoOverlayYEndHigh 0x0028
#define RDVideoOverlayYEndLow 0x0027
#define RDVideoOverlayYStartHigh 0x0024
#define RDVideoOverlayYStartLow 0x0023
/* Region 0 Video Stream Processing (0x5000-0x5FFF) */
#define VSAControl 0x5900
#define VSACurrentLine 0x5910
#define VSBCurrentLine 0x5a10
#define VSADroppedFrames 0x59d8
#define VSAFifoControl 0x59b8
#define VSBFifoControl 0x5ab8
#define VSAInterruptLine 0x5908
#define VSBInterruptLine 0x5a08
#define VSATimeStamp0 0x59c0
#define VSATimeStamp1 0x59c8
#define VSATimeStamp2 0x59d0
#define VSAVBIAddress0 0x5978
#define VSAVideoAddress0 0x5928
#define VSBVBIAddress0 0x5a78
#define VSBVideoAddress0 0x5a28
#define VSAVBIAddress1 0x5980
#define VSAVideoAddress1 0x5930
#define VSBVBIAddress1 0x5a80
#define VSBVideoAddress1 0x5a30
#define VSAVBIAddress2 0x5988
#define VSAVideoAddress2 0x5938
#define VSBVBIAddress2 0x5a88
#define VSBVideoAddress2 0x5a38
#define VSAVBIAddressHost 0x5968
#define VSBVBIAddressHost 0x5a68
#define VSAVBIAddressIndex 0x5970
#define VSAVideoAddressIndex 0x5920
#define VSAVBIEndData 0x59b0
#define VSBVBIEndData 0x5ab0
#define VSAVBIEndLine 0x59a0
#define VSBVBIEndLine 0x5aa0
#define VSAVBIStartData 0x59a8
#define VSBVBIStartData 0x5aa8
#define VSAVBIStartLine 0x5998
#define VSBVBIStartLine 0x5a98
#define VSAVBIStride 0x5990
#define VSAVideoStride 0x5940
#define VSBVBIStride 0x5a90
#define VSBVideoStride 0x5a40
#define VSAVBIAddress0 0x5978
#define VSAVideoAddress0 0x5928
#define VSBVBIAddress0 0x5a78
#define VSBVideoAddress0 0x5a28
#define VSAVBIAddress1 0x5980
#define VSAVideoAddress1 0x5930
#define VSBVBIAddress1 0x5a80
#define VSBVideoAddress1 0x5a30
#define VSAVBIAddress2 0x5988
#define VSAVideoAddress2 0x5938
#define VSBVBIAddress2 0x5a88
#define VSBVideoAddress2 0x5a38
#define VSAVideoAddressHost 0x5918
#define VSBVideoAddressHost 0x5a18
#define VSAVideoEndData 0x5960
#define VSBVideoEndData 0x5a60
#define VSAVideoEndLine 0x5950
#define VSBVideoEndLine 0x5a50
#define VSAVideoStartData 0x5958
#define VSBVideoStartData 0x5a58
#define VSAVideoStartLine 0x5948
#define VSBVideoStartLine 0x5a48
#define VSBControl 0x5a00
#define VSBVBIAddressIndex 0x5a70
#define VSBVideoAddressIndex 0x5a20
#define VSConfiguration 0x5800
#define VSDMACommandBase 0x5ac8
#define VSDMACommandCount 0x5ad0
#define VSDMAMode 0x5ac0
#define VSSerialBusControl 0x5810
#define VSStatus 0x5808
/* Region 3 Indirect Addressing */
#define IndirectAccess 0x000c
#define IndirectAddr 0x0008
#define IndirectByteEnable 0x0000
#define IndirectData 0x0004

/* Region 0 Graphics Registers (0x8000-0xFFFF) */
#define AlphaBlendAlphaMode 0xafa8
#define AlphaBlendAlphaModeAnd 0xaf30
#define AlphaBlendAlphaModeOr 0xaf38
#define AlphaBlendColorMode 0xafa0
#define AlphaBlendColorModeAnd 0xacb0
#define AlphaBlendColorModeOr 0xacb8
#define AlphaDestColor 0xaf88
#define AlphaSourceColor 0xaf80
#define AlphaTestMode 0x8800
#define AlphaTestModeAnd 0xabf0
#define AlphaTestModeOr 0xabf8
#define AntialiasMode 0x8808
#define AntialiasModeAnd 0xabf0
#define AntialiasModeOr 0xabf8 /* Uhh, these match AlphaTestMode{And,Or} */
#define AreaStippleMode 0x81a0
#define AreaStippleModeAnd 0xabd0
#define AreaStippleModeOr 0xabd8
/* #define AreaStipplePattern[0..31] 0x8200 - 0x82f8 FIXME */
#define AStart 0x87c8
#define BackgroundColor 0xb0c8
#define BasePageOfWorkingSet 0xb4c8
#define BasePageOfWorkingSetHost 0Xb4e0
#define BitMaskPattern 0x8068
#define BorderColor0 0x84a8
#define BorderColor1 0x84f8
#define BStart 0x87b0
#define ChromaFailColor 0xaf98
#define ChromaLower 0x8f10
#define ChromaPassColor 0xaf90
#define ChromaTestMode 0x8f18
#define ChromaTestModeAnd 0xacc0
#define ChromaTestModeOr 0xacc8
#define ChromaUpper 0x8f08
#define Color 0x87f0
#define ColorDDAMode 0x87e0
#define ColorDDAModeAnd 0xabe0
#define ColorDDAModeOr 0xabe8
#define CommandInterrupt 0xa990
#define Config2D 0xb618
#define ConstantColor 0x87e8
#define ConstantColorDDA 0xafb0
#define ContextData 0x8dd0
#define ContextDump 0x8dc0
#define ContextRestore 0x8dc8
#define Continue 0x8058
#define ContinueNewDom 0x8048
#define ContinueNewLine 0x8040
#define ContinueNewSub 0x8050
#define Count 0x8030
#define dAdx 0x87d0
#define dAdyDom 0x87d8
#define dBdx 0x87b8
#define dBdyDom 0x87c0
#define DeltaFormatControl 0x9350
#define DeltaFormatControlAnd 0xab20
#define DeltaFormatControlOr 0xab28
#define DeltaMode 0x9300
#define DeltaModeAnd 0xaad0
#define DeltaModeOr 0xaad8
#define Depth 0x89a8
#define DepthMode 0x89a0
#define DepthModeAnd 0xac70
#define DepthModeOr 0xac78
#define dFdx 0x86a8
#define dFdyDom 0x86b0
#define dGdx 0x87a0
#define dGdyDom 0x87a8
#define DitherMode 0x8818
#define DitherModeAnd 0xacd0
#define DitherModeOr 0xacd8
#define dKdBdx 0x8d38
#define dKdBdyDom 0x8d40
#define dKdGdx 0x8d20
#define dKdGdyDom 0x8d28
#define dKdRdx 0x8d08
#define dKdRdyDom 0x8d10
#define dKsBdx 0x8cb8
#define dKsBdyDom 0x8cc0
#define dKsdx 0x86d0
#define dKsdyDom 0x86d8
#define dKsGdx 0x8ca0
#define dKsGdyDom 0x8ca8
#define dKsRdx 0x8c88
#define dKsRdyDom 0x8cc0
#define DMAAddr 0xa980
#define DMAContinue 0xa9f8
#define DMACount 0xa988
#define DMAFeedback 0xaa10
#define DMAMemoryControl 0xb780
#define DMAOutputAddress 0xa9e0
#define DMAOutputCount 0xa9e8
#define DMARectangleRead 0xa9a8
#define DMARectangleReadAddress 0xa9b0
#define DMARectangleReadLinePitch 0xa9b8
#define DMARectangleReadTarget 0xa9c0
#define DMARectangleWrite 0xa9c8
#define DMARectangleWriteAddress 0XA9D0
#define DMARectangleWriteLinePitch 0XA9D8
#define DownloadAddress 0xb0d0
#define DownloadData 0xb0d8
#define DownloadGlyphWidth 0xb658
#define DownloadTarget 0xb650
#define dQ1dx 0x8438
#define dQ1dyDom 0x8440
#define dQdx 0x83c0
#define dQdy 0x83e8
#define dQdyDom 0x83c8
#define DrawLine0 0x9318
#define DrawLine1 0x9320
#define DrawLine2D01 0x9778
#define DrawLine2D10 0x9768
#define DrawPoint 0x9330
#define DrawTriangle 0x9308
#define dRdx 0x8788
#define dRdyDom 0x8790
#define dS1dx 0x8408
#define dS1dyDom 0x8410
#define DSdx 0x8390
#define DSdy 0x83d8
#define DSdyDom 0x8398
#define DT1dx 0x8420
#define DT1dyDom 0x8428
#define dTdx 0x83a8
#define dTdy 0x83e0
#define dTdyDom 0x83b0
#define dxDom 0x8008
#define dxSub 0x8018
#define dY 0x8028
#define dZdxL 0x89c8
#define dZdxU 0x89c0
#define dZdyDomL 0x89d8
#define dZdyDomU 0x89d0
#define EndOfFeedback 0x8ff8
#define FBBlockColor 0x8ac8
/* #define FBBlockColor[0..3] 0XB060 - 0xb078 FIXME */
#define FBBlockColorBack 0xb0a0
/* #define FBBlockColorBack[0..3] 0XB080 - 0xb098 */
#define FBColor 0x8a98
/* #define FBDestReadBufferAddr[0..3] 0xae80 - 0xae98 */
/* #define FBDestReadBufferOffset[0..3] 0xaea0 - 0xaeb8 */
#define FBDestData 0x8aa0 /* called FBData in manual */
/* #define FBDestReadBufferOffset[0..3] 0xae10 - 0xae28 */ /* Uhh, wtf. Same name as above? */
/* #define FBDestReadBufferWidth[0..3] 0xaec0 - 0xaed8 */
#define FBDestReadEnables 0xaee8
#define FBDestReadEnablesAnd 0xad20
#define FBDestReadEnablesOr 0xad28
#define FBDestReadMode 0xaee0
#define FBDestReadModeAnd 0xac90
#define FBDestReadModeOr 0xac98
#define FBHardwareWriteMask 0x8ac0
#define FBSoftwareWriteMask 0x8820
#define FBSourceData 0x8aa8
#define FBSourceReadBufferAddr 0xaf08
#define FBSourceReadBufferOffset 0xaf10
#define FBSourceReadBufferWidth 0xaf18
#define FBSourceReadMode 0xaf00
#define FBSourceReadModeAnd 0xaca0
#define FBSourceReadModeOr 0xaca8
/* #define FBWriteBufferAddr[0..3] 0xb000 - 0xb018 */
/* #define FBWriteBufferOffset[0..3] 0xb020 - 0xb038 */
/* #define FBWriteBufferWidth[0..3] 0xb040 - 0xb058 */
#define FBWriteMode 0x8ab8
#define FBWriteModeAnd 0xacf0
#define FBWriteModeOr 0xacf8
#define FeedbackX 0x8f88
#define FeedbackY 0x8f90
#define FillBackgroundColor 0x8330
#define FillConfig2D0 0x8338
#define FillConfig2D1 0x8360
#define FillFBDestReadBufferAddr0 0x8310
#define FillFBSourceReadBufferAddr 0x8308
#define FillFBSourceReadBufferOffset0 0x8340
#define FillFBWriteBufferAddr0 0x8300
#define FillForegroundColor0 0x8328
#define FillForegroundColor1 0x8358
#define FillGlyphPosition 0x8368
#define FillRectanglePosition 0x8348
#define FillRender2D 0x8350
#define FillScissorMaxXY 0x8320
#define FillScissorMinXY 0x8318
#define FilterMode 0x8c00
#define FilterModeAnd 0xad00
#define FilterModeOr 0xad08
#define FlushSpan 0x8060
#define FlushWriteCombining 0x8910
#define FogColor 0x8698
#define FogMode 0x8690
#define FogModeAnd 0xac10
#define FogModeOr 0xac18
/* #define FogTable[0..63] 0xb100 - 0xb2f8 */
#define ForegroundColor 0xb0c0
#define FStart 0x86a0
#define GIDMode 0xb538
#define GIDModeAnd 0xb5b0
#define GIDModeOr 0xb5b8
#define GlyphData 0xb660
#define GlyphPosition 0xb608
#define GStart 0x8798
/* #define HeadPhysicalPageAllocation[0..3] 0xb480 - 0xb... */
#define HostinDMAAddr 0x8938 /* called DMAAddr in manual */
#define HostinID 0x8900
#define HostInState 0x8918
#define HostInState2 0x8940
#define IndexBaseAddress 0xb700
#define IndexedDoubleVertex 0xb7b0
#define IndexedLineList 0xb728
#define IndexedLineStrip 0xb730
#define IndexedPointList 0xb738
#define IndexedPolygon 0xb740
#define IndexedTriangleFan 0xb718
#define IndexedTriangleList 0xb710
#define IndexedTriangleStrip 0xb720
#define IndexedVertex 0xb7a8
#define InvalidateCache 0xb358
#define KdBStart 0x8d30
#define KdGStart 0x8d18
#define KdRStart 0x8d00
#define KdStart 0x86e0
#define KsBStart 0x8cb0
#define KsGStart 0x8c98
#define KsRStart 0x8c80
#define LBClearDataL 0xb550
#define LBDepth 0x88b0
#define LBDestReadBufferAddr 0xb510
#define LBDestReadBufferOffset 0xb518
#define LBDestReadEnables 0xb508
#define LBDestReadEnablesAnd 0xb590
#define LBDestReadEnablesOr 0xb598
#define LBDestReadMode 0xb500
#define LBDestReadModeAnd 0xb580
#define LBDestReadModeOr 0xb588
#define LBReadFormat 0x8888
#define LBSourceReadBufferAddr 0xb528
#define LBSourceReadBufferOffset 0xb530
#define LBSourceReadMode 0xb520
#define LBSourceReadModeAnd 0xb5a0
#define LBSourceReadModeOr 0xb5a8
#define LBStencil 0x88a8
#define LBWriteBufferAddr 0xb540
#define LBWriteBufferOffset 0xb548
#define LBWriteFormat 0x88c8
#define LBWriteMode 0x88c0
#define LBWriteModeAnd 0xac80
#define LBWriteModeOr 0xac88
#define LineCoord0 0x9760
#define LineCoord1 0x9770
#define LineStippleMode 0x81a8
#define LineStippleModeAnd 0xabc0
#define LineStippleModeOr 0xabc8
#define LoadLineStippleCounters 0x81b0
#define LOD 0x83d0
#define LOD1 0x8448
#define LODRange0 0xb348
#define LODRange1 0xb350
#define LogicalOpMode 0x8828
#define LogicalOpModeAnd 0xaec0
#define LogicalOpModeOr 0xaec8
#define LogicalTexturePageTableAddr 0XB4D0
#define LogicalTexturePageTableLength 0XB4D8
/* #define LUT[0..15] 0x8e80 */
#define LUTAddress 0x84d0
#define LUTData 0x84c8
#define LUTIndex 0x84c0
#define LUTMode 0xb378
#define LUTModeAnd 0xad70
#define LUTModeOr 0xad78
#define LUTTransfer 0x84d8
#define MaxHitRegion 0x8c30
#define MaxRegion 0x8c18
#define MinHitRegion 0x8c28
#define MinRegion 0x8c10
#define Packed16Pixels 0xb638
#define Packed4Pixels 0xb668 /* called Pack16Pixels in manual */
#define Packed8Pixels 0xb630
#define PhysicalPageAllocationTableAddr 0XB4C0
#define PickResult 0x8c38
#define PixelSize 0x80c0
/* #define PointTable[0..3] 0x8080 - 0x8098 */
#define ProvokingVertex 0x9338
#define ProvokingVertexMask 0x9358
#define Q1Start 0x8430
#define QStart 0x83b8
#define RasterizerMode 0x80a0
#define RasterizerModeAnd 0xaba0
#define RasterizerModeOr 0xaba8
#define RectanglePosition 0xb600
#define Render 0x8038
#define Render2D 0xb640
#define Render2DGlyph 0xb648
#define RenderPatchOffset 0xb610
#define RepeatLine 0x9328
#define RepeatTriangle 0x9310
#define ResetPickResult 0x8c20
#define RetainedRender 0xb7a0
#define RLCount 0xb678
#define RLData 0xb670
#define RLEMask 0x8c48
#define RouterMode 0x8840
#define RStart 0x8780
#define S1Start 0x8400
#define SaveLineStippleCounters 0x81c0
#define ScissorMaxXY 0x8190
#define ScissorMinXY 0x8188
#define ScissorMode 0x8180
#define ScissorModeAnd 0xabb0
#define ScissorModeOr 0xabb8
#define ScreenSize 0x8198
#define Security 0x8908
#define SetLogicalTexturePage 0xb360
#define SStart 0x8388
#define StartXDom 0X8000
#define StartXSub 0X8010
#define StartY 0X8020
#define StatisticMode 0x8c08
#define StatisticModeAnd 0xad10
#define StatisticModeOr 0xad18
#define Stencil 0x8998
#define StencilData 0x8990
#define StencilDataAnd 0xb3e0
#define StencilDataOr 0xb3e8
#define StencilMode 0x8988
#define StencilModeAnd 0xac60
#define StencilModeOr 0xac68
#define StripeOffsetY 0x80c8
#define SuspendUntilFrameBlank 0x8c78
#define Synchronization 0x8c40 /* called Sync in manual */
#define T1Start 0x8418
/* #define TailPhysicalPageAllocation[0..3] 0xb4a0 - 0xb4b8 */
#define TextRender2DGlyph0 0x8708
#define TextRender2DGlyph1 0x8718
#define TextRender2DGlyph2 0x8728
#define TextRender2DGlyph3 0x8738
#define TextRender2DGlyph4 0x8748
#define TextRender2DGlyph5 0x8758
#define TextRender2DGlyph6 0x8768
#define TextRender2DGlyph7 0x8778
#define TextGlyphAddr0 0x8700
#define TextGlyphAddr1 0x8710
#define TextGlyphAddr2 0x8720
#define TextGlyphAddr3 0x8730
#define TextGlyphAddr4 0x8740
#define TextGlyphAddr5 0x8750
#define TextGlyphAddr6 0x8760
#define TextGlyphAddr7 0x8770
#define TextureApplicationMode 0x8680
#define TextureApplicationModeAnd 0xac50
#define TextureApplicationModeOr 0xac58
/* #define TextureBaseAddr[0..15] 0x8500 - */
#define TextureChromaLower0 0x84f0
#define TextureChromaUpper0 0x84e8
#define TextureChromaLower1 0x8600
#define TextureChromaUpper1 0x8608
#define TextureCompositeAlphaMode0 0xb310
#define TextureCompositeAlphaMode0And 0xb390
#define TextureCompositeAlphaMode0Or 0xb398
#define TextureCompositeAlphaMode1 0xb320
#define TextureCompositeAlphaMode1And 0xb3b0
#define TextureCompositeAlphaMode1Or 0xb3b8
#define TextureCompositeColorMode0 0xb308
#define TextureCompositeColorMode0And 0xb380
#define TextureCompositeColorMode0Or 0xb388
#define TextureCompositeColorMode1 0xb318
#define TextureCompositeColorMode1And 0xb3a0
#define TextureCompositeColorMode1Or 0xb3a8
#define TextureCompositeFactor0 0xb328
#define TextureCompositeFactor1 0xb330
#define TextureCompositeMode 0xb300
#define TextureCoordMode 0x8380
#define TextureCoordModeAnd 0xac20
#define TextureCoordModeOr 0xac28
#define TextureEnvironmentColor 0x8688 /* called TextureEnvColor in manual */
#define TextureFilterMode 0x84e0
#define TextureFilterModeAnd 0xad50
#define TextureFilterModeOr 0xad58
#define TextureIndexMode0 0xb338
#define TextureIndexMode0And 0xb3c0
#define TextureIndexMode0Or 0xb3c8
#define TextureIndexMode1 0xb340
#define TextureIndexMode1And 0xb3d0
#define TextureIndexMode1Or 0xb3d8
#define TextureLodBiasS 0x8450
#define TextureLodBiasT 0x8458
#define TextureLODScale 0x9340
#define TextureLODScale1 0x9348
#define TextureMapSize 0xb428
/* #define TextureMapWidth[0..15] 0x8580 - */
#define TextureReadMode0 0xb400
#define TextureReadMode0And 0xac30
#define TextureReadMode0Or 0xac38
#define TextureReadMode1 0xb408
#define TextureReadMode1And 0xad40
#define TextureReadMode1Or 0xad48
#define TouchLogicalPage 0xb370
#define TStart 0x83a0
#define UpdateLineStippleCounters 0x81b8
#define UpdateLogicalTextureInfo 0xb368
#define V0FloatR 0x91a8
#define V0FloatG 0x91b0
#define V0FloatB 0x91b8
#define V0FloatA 0x91c0
#define V0FloatF 0x91c8
#define V0FloatX 0x91d0
#define V0FloatY 0x91d8
#define V0FloatZ 0x91e0
#define V0FloatKdR 0x9068
#define V0FloatKdG 0x9070
#define V0FloatKdB 0x9078
#define V0FloatKsR 0x9050
#define V0FloatKsG 0x9058
#define V0FloatKsB 0x9060
#define V0FloatPackedColor 0x91f0
#define V0FloatPackedDiffuse 0x9048
#define V0FloatPackedSpecularFog 0x91f8
#define V0FloatS 0x9180
#define V0FloatT 0x9188
#define V0FloatQ 0x9190
#define V0FloatS1 0x9000
#define V0FloatT1 0x9008
#define V0FloatQ1 0x9010
#define V1FloatR 0x9228
#define V1FloatG 0x9230
#define V1FloatB 0x9238
#define V1FloatA 0x9240
#define V1FloatF 0x9248
#define V1FloatX 0x9250
#define V1FloatY 0x9258
#define V1FloatZ 0x9260
#define V1FloatKdR 0x90e8
#define V1FloatKdG 0x90f0
#define V1FloatKdB 0x90f8
#define V1FloatKsR 0x90d0
#define V1FloatKsG 0x90d8
#define V1FloatKsB 0x90e0
#define V1FloatPackedColor 0x9270
#define V1FloatPackedDiffuse 0x90c8
#define V1FloatPackedSpecularFog 0x9278
#define V1FloatS 0x9200
#define V1FloatT 0x9208
#define V1FloatQ 0x9210
#define V1FloatS1 0x9080
#define V1FloatT1 0x9088
#define V1FloatQ1 0x9090
#define V2FloatR 0x92a8
#define V2FloatG 0x92b0
#define V2FloatB 0x92b8
#define V2FloatA 0x92c0
#define V2FloatF 0x92c8
#define V2FloatX 0x92d0
#define V2FloatY 0x92d8
#define V2FloatZ 0x92e0
#define V2FloatKdR 0x9168
#define V2FloatKdG 0x9170
#define V2FloatKdB 0x9178
#define V2FloatKsR 0x9150
#define V2FloatKsG 0x9158
#define V2FloatKsB 0x9160
#define V2FloatPackedColor 0x92f0
#define V2FloatPackedDiffuse 0x9148
#define V2FloatPackedSpecularFog 0x92f8
#define V2FloatS 0x9280
#define V2FloatT 0x9288
#define V2FloatQ 0x9290
#define V2FloatS1 0x9100
#define V2FloatT1 0x9108
#define V2FloatQ1 0x9110
#define Vertex0 0xb7b8
#define Vertex1 0xb7c0
#define Vertex2 0xb7c8
#define VertexBaseAddress 0xb708
#define VertexControl 0xb798
#define VertexData 0xb7e8
#define VertexData0 0xb7d0
#define VertexData1 0xb7d8
#define VertexData2 0xb7e0
#define VertexFormat 0xb790
#define VertexLineList 0xb760
#define VertexLineStrip 0xb768
#define VertexPointList 0xb770
#define VertexPolygon 0xb778
/* #define VertexTagList[0..15] 0xb800 - */
/* #define VertexTagList[16..31] 0xb880 - */
#define VertexTriangleFan 0xb750
#define VertexTriangleList 0xb748
#define VertexTriangleStrip 0xb750
#define VertexValid 0xb788
#define VTGAddress 0xb0b0
#define VTGData 0xb0b8 /* manual mistakenly lists this as VTGAddress */
#define WaitforCompletion 0x80b8
#define Window 0x8980
#define WindowOrigin 0x81c8
#define XBias 0x9480
#define YBias 0x9488
#define YLimits 0x80a8
#define YUVMode 0x8f00
#define ZBias 0x94F8
#define ZFogBias 0x86b8
#define ZStartL 0x89b8
#define ZStartU 0x89b0
