#!/usr/bin/perl

# Searches for consecutive offsets whose difference is not 8.

use strict;
use warnings;
use integer;

die() if ($#ARGV != 0);

if (!open(FILE, $ARGV[0])) {
	die("Cannot open " . $ARGV[0]);
}

my $previous;
my @word;

while (chomp(my $line = <FILE>)) {
	if ($line ne '') {
		$previous = $word[0];
		@word = split(/ /, $line);
		if ($line =~ m/^0x/ && $previous ne '/*') {
			if ((hex($word[0]) - hex($previous)) != 8) {
				print "spacing between ", $previous, " and ", $word[0], "\n";
			}
		}
	}
}

close(FILE);
